diff --git a/game/core/src/main/java/net/minecraft/core/block/Blocks.java b/game/core/src/main/java/net/minecraft/core/block/Blocks.java
index 836c549aa..0e8aedef7 100644
--- a/game/core/src/main/java/net/minecraft/core/block/Blocks.java
+++ b/game/core/src/main/java/net/minecraft/core/block/Blocks.java
@@ -11,6 +11,7 @@ import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.data.tag.Tag;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.Mob;
+import net.minecraft.core.entity.animal.MobButterfly;
 import net.minecraft.core.entity.animal.MobFireflyCluster;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.item.Item;
@@ -21,6 +22,7 @@ import net.minecraft.core.item.block.ItemBlockPainted;
 import net.minecraft.core.item.block.ItemBlockStairsPainted;
 import net.minecraft.core.item.block.ItemBlockLamp;
 import net.minecraft.core.item.block.ItemBlockSlabPainted;
+import net.minecraft.core.sound.BlockSound;
 import net.minecraft.core.sound.BlockSounds;
 import net.minecraft.core.util.collection.NamespaceID;
 import net.minecraft.core.world.Dimension;
@@ -425,6 +427,9 @@ public final class Blocks {
     public static final Block<?> GRAVEL = register("gravel", "minecraft:block/gravel", 251, BlockLogicGravel::new)
         .withSound(BlockSounds.GRAVEL).withHardness(0.6F)
         .withTags(BlockTags.MINEABLE_BY_SHOVEL);
+    public static final Block<?> SULFUR = register("sulfur", "minecraft:block/sulfur", 252, (b) -> new BlockLogic(b, Material.sand))
+            .withSound(BlockSounds.SAND).withHardness(0.7F)
+        .withTags(BlockTags.MINEABLE_BY_SHOVEL);
 
     public static final Block<?> BEDROCK = register("bedrock", "minecraft:block/bedrock", 260, (b) -> new BlockLogicBedrock(b, Material.stone))
         .withSound(BlockSounds.STONE).withSetUnbreakable().withBlastResistance(6000000F).withImmovableFlagSet()
@@ -916,6 +921,9 @@ public final class Blocks {
     public static final Block<BlockLogicBrazier> BRAZIER_ACTIVE = register("brazier.active", "minecraft:block/brazier_active", 632, (BlockLogicSupplier<BlockLogicBrazier>)b -> new BlockLogicBrazier(b, true))
         .withSound(BlockSounds.FIRE).withHardness(1.5F).withLightEmission(1.0F).setStatParent(() -> BRAZIER_INACTIVE)
         .withTags(BlockTags.NOT_IN_CREATIVE_MENU, BlockTags.MINEABLE_BY_PICKAXE);
+    public static final Block<BlockLogicFireCold> FIRE_COLD = register("fire_cold", "minecraft:block/fire_cold", 633, BlockLogicFireCold::new)
+        .withSound(BlockSounds.FIRE).withHardness(0.0F).withLightEmission(1.0F).withDisabledStats().withDisabledNeighborNotifyOnMetadataChange()
+        .withTags(BlockTags.BROKEN_BY_FLUIDS, BlockTags.PLACE_OVERWRITES, BlockTags.NOT_IN_CREATIVE_MENU);
 
     public static final Block<?> MOBSPAWNER = register("mobspawner", "minecraft:block/mobspawner", 640, BlockLogicMobSpawner::new)
         .withSound(BlockSounds.METAL).withHardness(5F).withImmovableFlagSet()
@@ -995,6 +1003,9 @@ public final class Blocks {
     public static final Block<?> LAYER_SLATE = register("layer.slate", "minecraft:block/layer_slate", 722, (b) -> new BlockLogicLayerSlate(b, Blocks.SLATE, Material.slate))
         .withSound(BlockSounds.STONE).withHardness(1.5F).withBlastResistance(10F).withLitInteriorSurface(true)
         .withTags(BlockTags.MINEABLE_BY_PICKAXE);
+    public static final Block<BlockLogicLayerAsh> LAYER_ASH = register("layer.ash", "minecraft:block/layer_ash", 723, (BlockLogicSupplier<BlockLogicLayerAsh>)(b) -> new BlockLogicLayerAsh(b, Blocks.BLOCK_ASH, Material.topAsh))
+        .withSound(BlockSounds.CLOTH).withHardness(0.1F).withLitInteriorSurface(true)
+        .withTags(BlockTags.BROKEN_BY_FLUIDS, BlockTags.PLACE_OVERWRITES, BlockTags.MINEABLE_BY_SHOVEL, BlockTags.OVERRIDE_STEPSOUND);
 
     public static final Block<?> ICE = register("ice", "minecraft:block/ice", 730, BlockLogicIce::new)
         .withSound(BlockSounds.GLASS).withHardness(0.5F).withLightBlock(3)
@@ -1006,6 +1017,9 @@ public final class Blocks {
     public static final Block<?> BLOCK_SNOW = register("block.snow", "minecraft:block/block_snow", 740, BlockLogicSnow::new)
         .withSound(BlockSounds.CLOTH).withHardness(0.2F)
         .withTags(BlockTags.CAVES_CUT_THROUGH, BlockTags.MINEABLE_BY_SHOVEL, BlockTags.FIREFLIES_CAN_SPAWN);
+    public static final Block<?> BLOCK_ASH = register("block.ash", "minecraft:block/block_ash", 741, BlockLogicAsh::new)
+        .withSound(BlockSounds.CLOTH).withHardness(0.2F)
+        .withTags(BlockTags.CAVES_CUT_THROUGH, BlockTags.MINEABLE_BY_SHOVEL);
 
     public static final Block<?> CACTUS = register("cactus", "minecraft:block/cactus", 750, BlockLogicCactus::new)
         .withSound(BlockSounds.CLOTH).withHardness(0.4F)
@@ -1075,7 +1089,7 @@ public final class Blocks {
 
     public static final Block<?> SOULSAND = register("soulsand", "minecraft:block/soulsand", 810, BlockLogicSoulSand::new)
         .withSound(BlockSounds.SAND).withHardness(0.5F).withOverrideColor(MaterialColor.paintedBrown)
-        .withTags(BlockTags.MINEABLE_BY_SHOVEL, BlockTags.CAVES_CUT_THROUGH, BlockTags.NETHER_MOBS_SPAWN);
+        .withTags(BlockTags.MINEABLE_BY_SHOVEL, BlockTags.CAVES_CUT_THROUGH, BlockTags.NETHER_MOBS_SPAWN, BlockTags.INFINITE_BURN_COLD);
     public static final Block<?> SOULSCHIST = register("soulschist", "minecraft:block/soulschist", 811, (b) -> new BlockLogicCobble(b, Material.stone, () -> Blocks.SOULSAND))
         .withSound(BlockSounds.STONE).withHardness(2.0F).withBlastResistance(10F).withOverrideColor(MaterialColor.paintedBrown)
         .withTags(BlockTags.MINEABLE_BY_PICKAXE, BlockTags.NETHER_MOBS_SPAWN);
@@ -1083,6 +1097,15 @@ public final class Blocks {
     public static final Block<?> GLOWSTONE = register("glowstone", "minecraft:block/glowstone", 820, (b) -> new BlockLogicGlowStone(b, Material.stone))
         .withSound(BlockSounds.GLASS).withHardness(0.3F).withLightEmission(1.0F).withOverrideColor(MaterialColor.paintedYellow)
         .withTags(BlockTags.MINEABLE_BY_PICKAXE);
+    public static final Block<?> CRYSTAL = register("crystal", "minecraft:block/crystal", 821, (b) -> new BlockLogicCrystal(b))
+        .withSound(BlockSounds.GLASS).withLightEmission(0.8F)
+        .withTags(BlockTags.MINEABLE_BY_PICKAXE);
+    public static final Block<?> CRYSTAL_STALK = register("crystal.stalk", "minecraft:block/crystal_stalk", 822, (b) -> new BlockLogicStalk(b))
+        .withSound(BlockSounds.GLASS).withDisabledNeighborNotifyOnMetadataChange().withLightEmission(0.8F)
+        .withTags(BlockTags.MINEABLE_BY_PICKAXE);
+    public static final Block<?> NETHERRACK_CRYSTALLINE = register("netherrack.crystalline", "minecraft:block/netherrack_crystalline", 823, (b) -> new BlockLogic(b, Material.stone))
+        .withSound(BlockSounds.STONE).withDisabledNeighborNotifyOnMetadataChange()
+        .withTags(BlockTags.MINEABLE_BY_PICKAXE, BlockTags.INFINITE_BURN, BlockTags.CAVES_CUT_THROUGH, BlockTags.NETHER_MOBS_SPAWN);
 
     public static final Block<BlockLogicPortal> PORTAL_NETHER = register("portal.nether", "minecraft:block/portal_nether", 830, (BlockLogicSupplier<BlockLogicPortal>) b -> new BlockLogicPortal(b, Dimension.NETHER, Blocks.OBSIDIAN, Blocks.FIRE))
         .withSound(BlockSounds.GLASS).withHardness(-1F).withLightEmission(0.75F).withOverrideColor(MaterialColor.paintedPurple).withDisabledStats()
@@ -1156,6 +1179,19 @@ public final class Blocks {
         .withSound(BlockSounds.CLOTH).withHardness(0.7F)
         .withTags(BlockTags.MINEABLE_BY_SHEARS, BlockTags.FENCES_CONNECT, BlockTags.CAN_HANG_OFF, BlockTags.MINEABLE_BY_AXE);
 
+    public static final Block<?> JAR_BUTTERFLY_BLUE = register("jar.butterfly.blue", "minecraft:block/jar_butterfly_blue", 920, (b) -> new BlockLogicJarButterfly(b, MobButterfly.COLOR_BLUE, () -> Items.JAR_BUTTERFLY_BLUE))
+        .withSound(BlockSounds.GLASS).withHardness(0.1F).withDisabledNeighborNotifyOnMetadataChange().setStatParent(() -> Items.JAR_BUTTERFLY_BLUE)
+        .withTags(BlockTags.BROKEN_BY_FLUIDS, BlockTags.MINEABLE_BY_PICKAXE, BlockTags.NOT_IN_CREATIVE_MENU);
+    public static final Block<?> JAR_BUTTERFLY_ORANGE = register("jar.butterfly.orange", "minecraft:block/jar_butterfly_orange", 921, (b) -> new BlockLogicJarButterfly(b, MobButterfly.COLOR_ORANGE, () -> Items.JAR_BUTTERFLY_ORANGE))
+        .withSound(BlockSounds.GLASS).withHardness(0.1F).withDisabledNeighborNotifyOnMetadataChange().setStatParent(() -> Items.JAR_BUTTERFLY_ORANGE)
+        .withTags(BlockTags.BROKEN_BY_FLUIDS, BlockTags.MINEABLE_BY_PICKAXE, BlockTags.NOT_IN_CREATIVE_MENU);
+    public static final Block<?> JAR_BUTTERFLY_PINK = register("jar.butterfly.pink", "minecraft:block/jar_butterfly_pink", 922, (b) -> new BlockLogicJarButterfly(b, MobButterfly.COLOR_PINK, () -> Items.JAR_BUTTERFLY_PINK))
+        .withSound(BlockSounds.GLASS).withHardness(0.1F).withDisabledNeighborNotifyOnMetadataChange().setStatParent(() -> Items.JAR_BUTTERFLY_PINK)
+        .withTags(BlockTags.BROKEN_BY_FLUIDS, BlockTags.MINEABLE_BY_PICKAXE, BlockTags.NOT_IN_CREATIVE_MENU);
+    public static final Block<?> JAR_BUTTERFLY_SILVER = register("jar.butterfly.silver", "minecraft:block/jar_butterfly_silver", 923, (b) -> new BlockLogicJarButterfly(b, MobButterfly.COLOR_SILVER, () -> Items.JAR_BUTTERFLY_SILVER))
+        .withSound(BlockSounds.GLASS).withHardness(0.1F).withDisabledNeighborNotifyOnMetadataChange().setStatParent(() -> Items.JAR_BUTTERFLY_SILVER)
+        .withTags(BlockTags.BROKEN_BY_FLUIDS, BlockTags.MINEABLE_BY_PICKAXE, BlockTags.NOT_IN_CREATIVE_MENU);
+
     public static final Block<BlockLogicSlab> SLAB_BRICK_SANDSTONE = register("slab.brick.sandstone", "minecraft:block/slab_brick_sandstone", 1000, (BlockLogicSupplier<BlockLogicSlab>) b -> new BlockLogicSlab(b, Blocks.BRICK_SANDSTONE))
         .withSound(BlockSounds.STONE).withDisabledNeighborNotifyOnMetadataChange().withLitInteriorSurface(true)
         .withTags(BlockTags.MINEABLE_BY_PICKAXE);
@@ -1169,6 +1205,13 @@ public final class Blocks {
         .withSound(BlockSounds.PERMAFROST).withDisabledNeighborNotifyOnMetadataChange().withLitInteriorSurface(true)
         .withTags(BlockTags.MINEABLE_BY_PICKAXE);
 
+    public static final Block<BlockLogicStatue> STATUE_STONE_LOWER = register("statue.stone.lower", "minecraft:block/statue_lower", 1010, (BlockLogicSupplier<BlockLogicStatue>) b -> new BlockLogicStatue(b, Material.stone, true, () -> Items.STATUE_STONE))
+        .withSound(BlockSounds.STONE).withHardness(1.5F)
+        .withTags(BlockTags.MINEABLE_BY_PICKAXE, BlockTags.NOT_IN_CREATIVE_MENU);
+    public static final Block<BlockLogicStatue> STATUE_STONE_UPPER = register("statue.stone.upper", "minecraft:block/statue_upper", 1011, (BlockLogicSupplier<BlockLogicStatue>) b -> new BlockLogicStatue(b, Material.stone, false, () -> Items.STATUE_STONE))
+        .withSound(BlockSounds.STONE).withHardness(1.5F)
+        .withTags(BlockTags.MINEABLE_BY_PICKAXE, BlockTags.NOT_IN_CREATIVE_MENU);
+
     public static <T extends BlockLogic> Block<T> register(String key, String namespaceId, int id, BlockLogicSupplier<T> logicSupplier) {
         Block<T> container = new Block<>(id, key, namespaceId, logicSupplier);
 
@@ -1250,6 +1293,9 @@ public final class Blocks {
     @Nullable
     public static Block<?> getBlock(int id)
     {
+        if (id < 0 || id >= Blocks.blocksList.length) {
+            return null;
+        }
         return Blocks.blocksList[id];
     }
 
diff --git a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityDispatcher.java b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityDispatcher.java
index 1ee070d85..a5a326a4d 100644
--- a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityDispatcher.java
+++ b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityDispatcher.java
@@ -83,7 +83,9 @@ public class TileEntityDispatcher {
         addMapping(TileEntityFlag.class, new NamespaceID("minecraft", "flag"));
         addMapping(TileEntitySeat.class, new NamespaceID("minecraft", "seat"));
         addMapping(TileEntityFlowerJar.class, new NamespaceID("minecraft", "jar_flower"));
+        addMapping(TileEntityJarButterfly.class, new NamespaceID("minecraft", "jar_butterfly"));
         addMapping(TileEntityMeshGold.class, new NamespaceID("minecraft", "mesh_gold"));
+        addMapping(TileEntityStatue.class, new NamespaceID("minecraft", "statue_stone"));
     }
 
     @Deprecated
diff --git a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityJarButterfly.java b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityJarButterfly.java
new file mode 100644
index 000000000..b7f10d695
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityJarButterfly.java
@@ -0,0 +1,38 @@
+package net.minecraft.core.block.entity;
+
+import com.mojang.nbt.tags.CompoundTag;
+import net.minecraft.core.entity.animal.MobButterfly;
+
+public class TileEntityJarButterfly extends TileEntity{
+    public MobButterfly.ButterflyEntry color;
+    public int ticksRan = 0;
+
+    public TileEntityJarButterfly() {
+
+    }
+
+    public TileEntityJarButterfly(MobButterfly.ButterflyEntry color) {
+        this.color = color;
+    }
+
+    @Override
+    public void tick()
+    {
+        if (ticksRan == 0){
+            ticksRan = worldObj.rand.nextInt(360);
+        }
+        ticksRan++;
+    }
+
+    @Override
+    public void readFromNBT(CompoundTag compoundTag) {
+        super.readFromNBT(compoundTag);
+        color = MobButterfly.colorEntries.getOrDefault(compoundTag.getByte("color") & 0xFF, MobButterfly.COLOR_BLUE);
+    }
+
+    @Override
+    public void writeToNBT(CompoundTag compoundTag) {
+        super.writeToNBT(compoundTag);
+        compoundTag.putByte("color", (byte) color.id);
+    }
+}
diff --git a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityStatue.java b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityStatue.java
new file mode 100644
index 000000000..232058293
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityStatue.java
@@ -0,0 +1,140 @@
+package net.minecraft.core.block.entity;
+
+import com.mojang.nbt.tags.ByteTag;
+import com.mojang.nbt.tags.CompoundTag;
+import com.mojang.nbt.tags.ListTag;
+import com.mojang.nbt.tags.Tag;
+import net.minecraft.core.entity.IArmorWearing;
+import net.minecraft.core.enums.HumanArmorShape;
+import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.net.packet.Packet;
+import net.minecraft.core.net.packet.PacketBlockEntityData;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+
+public class TileEntityStatue extends TileEntity implements IArmorWearing<HumanArmorShape> {
+    public enum Pose {
+        DEFAULT(0.0f, 0.0f, 0.0f, 0.0f, 0.0f, 0.0f),
+        LEFT_ARM_UP(-2.2f, 0.0f, 0.0f, 0.0f, 0.0f, 0.0f),
+        RIGHT_ARM_UP(0.0f, -2.2f, 0.0f, 0.0f, 0.0f, 0.0f),
+        BOTH_ARMS_UP(-2.2f, -2.2f, 0.0f, 0.0f, 0.0f, 0.0f),
+        WALKING(0.75f, -0.75f, 0.5f, -0.5f, 0.0f, 0.0f),
+        LOOK_UP(0.0f, 0.0f, 0.0f, 0.0f, -0.3f, 0.0f),
+        LOOK_DOWN(0.0f, 0.0f, 0.0f, 0.0f, 0.3f, 0.0f),
+        LOOK_LEFT(0.0f, 0.0f, 0.0f, 0.0f, 0.0f, -1.0f),
+        LOOK_RIGHT(0.0f, 0.0f, 0.0f, 0.0f, 0.0f, 1.0f),
+        ;
+
+        public final float leftArmPitch;
+        public final float rightArmPitch;
+        public final float leftLegPitch;
+        public final float rightLegPitch;
+        public final float headPitch;
+        public final float headYaw;
+
+        Pose(final float leftArmPitch, final float rightArmPitch, final float leftLegPitch, final float rightLegPitch, final float headPitch, final float headYaw) {
+            this.leftArmPitch = leftArmPitch;
+            this.rightArmPitch = rightArmPitch;
+            this.leftLegPitch = leftLegPitch;
+            this.rightLegPitch = rightLegPitch;
+            this.headPitch = headPitch;
+            this.headYaw = headYaw;
+        }
+    }
+
+    private final @Nullable ItemStack @NotNull[] armorPieces = new ItemStack[HumanArmorShape.values().length];
+    private @NotNull Pose pose = Pose.DEFAULT;
+
+    @Override
+    public void writeToNBT(CompoundTag tag) {
+        super.writeToNBT(tag);
+
+        final @NotNull ListTag list = new ListTag();
+        for (int i = 0; i < getNumArmorSlots(); i++) {
+            final @Nullable HumanArmorShape slot = getArmorSlotByIndex(i);
+            if (slot != null) {
+                final @Nullable ItemStack itemInSlot = getItemInArmorSlot(slot);
+                if (itemInSlot != null) {
+                    final @NotNull CompoundTag armorTag = new CompoundTag();
+                    armorTag.putByte("Slot", (byte) i);
+                    itemInSlot.writeToNBT(armorTag);
+                    list.addTag(armorTag);
+                }
+            }
+        }
+        tag.putList("Armor", list);
+        tag.putByte("Pose", (byte) this.pose.ordinal());
+    }
+
+    @Override
+    public void readFromNBT(CompoundTag tag) {
+        super.readFromNBT(tag);
+
+        final @Nullable ListTag list = tag.getList("Armor");
+        if (list != null) {
+            for (Tag<?> t : list) {
+                if (t instanceof CompoundTag) {
+                    final @NotNull CompoundTag ct = (CompoundTag) t;
+                    final @Nullable Tag<?> t2 = ct.getTag("Slot");
+                    if (t2 instanceof ByteTag) {
+                        final @Nullable HumanArmorShape armorSlot = getArmorSlotByIndex(((ByteTag) t2).getValue());
+                        if (armorSlot != null) {
+                            final @Nullable ItemStack stack = ItemStack.readItemStackFromNbt(ct);
+                            if (stack != null) {
+                                setItemInArmorSlot(armorSlot, stack);
+                            }
+                        }
+                    }
+                }
+            }
+        }
+
+        byte pose = tag.getByteOrDefault("Pose", (byte) Pose.DEFAULT.ordinal());
+        if (pose < 0 || pose >= Pose.values().length) {
+            pose = (byte) Pose.DEFAULT.ordinal();
+        }
+        this.pose = Pose.values()[pose];
+    }
+
+    public @NotNull Pose getPose() {
+        return this.pose;
+    }
+
+    public void setPose(final @NotNull Pose pose) {
+        this.pose = pose;
+        setChanged();
+    }
+
+    public void nextPose() {
+        setPose(Pose.values()[(getPose().ordinal() + 1) % Pose.values().length]);
+    }
+
+    @Override
+    public @Nullable ItemStack getItemInArmorSlot(final @NotNull HumanArmorShape slot) {
+        return this.armorPieces[slot.getSlotIndex()];
+    }
+
+    @Override
+    public void setItemInArmorSlot(final @NotNull HumanArmorShape slot, final @Nullable ItemStack item) {
+        this.armorPieces[slot.getSlotIndex()] = item;
+        setChanged();
+    }
+
+    @Override
+    public int getNumArmorSlots() {
+        return HumanArmorShape.values().length;
+    }
+
+    @Override
+    public @Nullable HumanArmorShape getArmorSlotByIndex(final int index) {
+        if (index < 0 || index >= HumanArmorShape.values().length) {
+            return null;
+        }
+        return HumanArmorShape.values()[index];
+    }
+
+    @Override
+    public Packet getDescriptionPacket() {
+        return new PacketBlockEntityData(this);
+    }
+}
diff --git a/game/core/src/main/java/net/minecraft/core/block/material/Material.java b/game/core/src/main/java/net/minecraft/core/block/material/Material.java
index 69e27c55f..d46fa1686 100644
--- a/game/core/src/main/java/net/minecraft/core/block/material/Material.java
+++ b/game/core/src/main/java/net/minecraft/core/block/material/Material.java
@@ -171,6 +171,8 @@ public class Material
     public static final Material ice = new Material(MaterialColor.ice).notSolidBlocking();
     public static final Material topSnow = new MaterialDecoration(MaterialColor.snow).replaceable().notSolidBlocking().notAlwaysDestroyable().destroyOnPush();
     public static final Material snow = new Material(MaterialColor.snow).notAlwaysDestroyable();
+    public static final Material topAsh = new MaterialDecoration(MaterialColor.snow).replaceable().notSolidBlocking().notAlwaysDestroyable().destroyOnPush();
+    public static final Material ash = new Material(MaterialColor.snow).notAlwaysDestroyable();
     public static final Material cactus = new Material(MaterialColor.plant).notSolidBlocking().destroyOnPush();
     public static final Material clay = new Material(MaterialColor.clay);
     public static final Material vegetable = new Material(MaterialColor.plant).destroyOnPush();
diff --git a/game/core/src/main/java/net/minecraft/core/block/tag/BlockTags.java b/game/core/src/main/java/net/minecraft/core/block/tag/BlockTags.java
index 790e9c36f..e038508dc 100644
--- a/game/core/src/main/java/net/minecraft/core/block/tag/BlockTags.java
+++ b/game/core/src/main/java/net/minecraft/core/block/tag/BlockTags.java
@@ -148,6 +148,10 @@ public abstract class BlockTags
      * Block allows fire to burn forever on it {@link BlockLogicFire BlockFire}
      */
     public static Tag<Block<?>> INFINITE_BURN = Tag.of("infinite_burn");
+    /**
+     * Block allows fire to burn forever on it {@link BlockFire BlockFire}
+     */
+    public static Tag<Block<?>> INFINITE_BURN_COLD = Tag.of("infinite_burn_cold");
     /**
      * Block is broken on contact with an {@link EntityBoat EntityBoat}
      */
diff --git a/game/core/src/main/java/net/minecraft/core/entity/Entity.java b/game/core/src/main/java/net/minecraft/core/entity/Entity.java
index 632ec58df..920602191 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/Entity.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/Entity.java
@@ -5,8 +5,11 @@ import java.util.Random;
 
 import net.minecraft.core.block.BlockLogicFluid;
 import net.minecraft.core.block.Blocks;
+import net.minecraft.core.entity.vehicle.EntityBoat;
+import net.minecraft.core.entity.vehicle.MobGhastVehicle;
 import net.minecraft.core.util.collection.NamespaceID;
 import net.minecraft.core.util.helper.DyeColor;
+import net.minecraft.core.world.Dimension;
 import net.minecraft.core.world.ICarriable;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
@@ -312,6 +315,10 @@ public abstract class Entity
         {
             lavaHurt();
         }
+        if (isInWater())
+        {
+            waterHurt();
+        }
 
         if (y < -64D)
         {
@@ -374,6 +381,12 @@ public abstract class Entity
         }
     }
 
+    public void waterHurt() {
+        if (world != null && world.dimension == Dimension.NETHER && !(vehicle instanceof EntityBoat)) {
+            hurt(null, 1, DamageType.FIRE);
+        }
+    }
+
     public void lavaHurt()
     {
         if(!fireImmune)
@@ -1215,7 +1228,7 @@ public abstract class Entity
         if (vehicle == null) {
             return;
         }
-        if(vehicle.isRemoved() || isSneaking())
+        if(vehicle.isRemoved() || (isSneaking() && !(vehicle instanceof MobGhastVehicle)))
         {
             vehicle.ejectRider();
             return;
diff --git a/game/core/src/main/java/net/minecraft/core/entity/EntityDispatcher.java b/game/core/src/main/java/net/minecraft/core/entity/EntityDispatcher.java
index bddf1ccfb..7fb4b9ae6 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/EntityDispatcher.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/EntityDispatcher.java
@@ -6,6 +6,7 @@ import net.minecraft.core.entity.monster.*;
 import net.minecraft.core.entity.projectile.*;
 import net.minecraft.core.entity.vehicle.EntityBoat;
 import net.minecraft.core.entity.vehicle.MinecartEntity;
+import net.minecraft.core.entity.vehicle.MobGhastVehicle;
 import com.mojang.nbt.tags.CompoundTag;
 import net.minecraft.core.util.collection.NamespaceID;
 import net.minecraft.core.world.World;
@@ -208,6 +209,7 @@ public final class EntityDispatcher
         addMapping(MobGiant.class, new NamespaceID("minecraft", "giant"));
         addMapping(MobSlime.class, new NamespaceID("minecraft", "slime"), "guidebook.section.mob.slime.name");
         addMapping(MobGhast.class, new NamespaceID("minecraft", "ghast"), "guidebook.section.mob.ghast.name");
+        addMapping(MobGhastVehicle.class, new NamespaceID("minecraft", "ghast_vehicle"), "guidebook.section.mob.ghast.name");
         addMapping(MobSnowman.class, new NamespaceID("minecraft", "snowman"), "guidebook.section.mob.snowman.name");
 
         // Passive
@@ -219,6 +221,7 @@ public final class EntityDispatcher
         addMapping(MobSquid.class, new NamespaceID("minecraft", "squid"), "guidebook.section.mob.squid.name");
         addMapping(MobWolf.class, new NamespaceID("minecraft", "wolf"), "guidebook.section.mob.wolf.name");
         addMapping(MobFireflyCluster.class, new NamespaceID("minecraft", "firefly_cluster"), "guidebook.section.mob.firefly_cluster.name");
+        addMapping(MobButterfly.class, new NamespaceID("minecraft", "butterfly"), "guidebook.section.mob.butterfly.name");
     }
 
     @Deprecated
diff --git a/game/core/src/main/java/net/minecraft/core/entity/IArmorWearing.java b/game/core/src/main/java/net/minecraft/core/entity/IArmorWearing.java
new file mode 100644
index 000000000..600bba331
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/entity/IArmorWearing.java
@@ -0,0 +1,84 @@
+package net.minecraft.core.entity;
+
+import net.minecraft.core.enums.IArmorShape;
+import net.minecraft.core.item.*;
+import net.minecraft.core.item.material.ArmorMaterial;
+import net.minecraft.core.util.helper.DamageType;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+
+import java.util.Objects;
+
+public interface IArmorWearing<T extends IArmorShape> {
+    @Nullable ItemStack getItemInArmorSlot(final @NotNull T slot);
+
+    void setItemInArmorSlot(final @NotNull T slot, final @Nullable ItemStack item);
+
+    int getNumArmorSlots();
+
+    @Nullable T getArmorSlotByIndex(final int index);
+
+    default float getTotalProtectionAmount(final @NotNull DamageType damageType) {
+        float protectionPercentage = 0.0f;
+
+        for (int i = 0; i < getNumArmorSlots(); i++) {
+            final @NotNull T armorSlot = Objects.requireNonNull(getArmorSlotByIndex(i));
+            final @Nullable ItemStack armorItem = getItemInArmorSlot(armorSlot);
+            if (armorItem != null && armorItem.getItem() instanceof IArmorItem<?>) {
+                final @NotNull IArmorItem<?> armor = (IArmorItem<?>) armorItem.getItem();
+                final @Nullable ArmorMaterial material = armor.getArmorMaterial();
+                if (material != null) {
+                    protectionPercentage += material.getProtection(damageType) * armor.getArmorPieceProtectionPercentage();
+                }
+            }
+        }
+
+        return protectionPercentage;
+    }
+
+    default void damageArmor(final int damage, final @NotNull T armorSlot) {
+        final @Nullable ItemStack armorItem = getItemInArmorSlot(armorSlot);
+        if (armorItem != null && armorItem.getItem() instanceof IArmorItem<?>) {
+            final @NotNull IArmorItem<?> armor = (IArmorItem<?>) armorItem.getItem();
+            final @Nullable ArmorMaterial material = armor.getArmorMaterial();
+            if (material != null) {
+                if (this instanceof Entity) {
+                    armorItem.damageItem(damage, (Entity) this);
+                } else {
+                    armorItem.damageItem(damage, null);
+                }
+                if (armorItem.stackSize <= 0) {
+                    setItemInArmorSlot(armorSlot, null);
+                }
+            }
+        }
+    }
+
+    default void damageArmor(final int damage) {
+        for (int i = 0; i < getNumArmorSlots(); i++) {
+            final @NotNull T armorSlot = Objects.requireNonNull(getArmorSlotByIndex(i));
+            damageArmor(damage, armorSlot);
+        }
+    }
+
+    default boolean canItemGoInArmorSlot(final @NotNull T slot, final @Nullable ItemStack item) {
+        if (item == null) {
+            return false;
+        }
+
+        return canItemGoInArmorSlot(slot, item.getItem());
+    }
+
+    default boolean canItemGoInArmorSlot(final @NotNull T slot, final @Nullable IItemConvertible item) {
+        if (item == null || item.asItem() == null) {
+            return false;
+        }
+
+        final @NotNull Item realItem = item.asItem();
+        if (!(realItem instanceof IArmorItem)) {
+            return false;
+        }
+
+        return ((IArmorItem<T>) realItem).getArmorShape() == slot;
+    }
+}
